package jp.sourceforge.pdt_tools.adjustencoding.handlers;

import jp.sourceforge.pdt_tools.adjustencoding.AdjustEncoding;

import org.eclipse.core.commands.AbstractHandler;
import org.eclipse.core.commands.ExecutionEvent;
import org.eclipse.core.commands.ExecutionException;
import org.eclipse.core.resources.IFile;
import org.eclipse.core.resources.IResource;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.jface.viewers.ISelection;
import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.ui.handlers.HandlerUtil;

public class CommandHandler extends AbstractHandler {

	public CommandHandler() {
	}

	public Object execute(ExecutionEvent event) throws ExecutionException {
		ISelection selection = HandlerUtil.getCurrentSelectionChecked(event);
		if (selection instanceof IStructuredSelection) {
			for (Object item : ((IStructuredSelection) selection).toArray()) {
				if (!(item instanceof IFile) && item instanceof IAdaptable) {
					item = ((IAdaptable) item).getAdapter(IResource.class);
				}
				if (item instanceof IFile) {
					try {
						AdjustEncoding.getDefault()
								.adjustEncoding((IFile) item);
					} catch (CoreException e) {
						AdjustEncoding.getDefault().log(e);
					}
				}
			}
		}
		return null;
	}
}
